//+------------------------------------------------------------------+
//|                                                        RMS_V.mq4 |
//|                                    Copyright  2006, Alex Wilson |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Alex Wilson"
#property link      ""

#property indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  Black
#property  indicator_color2  Olive
#property  indicator_color3  Red
#property  indicator_color4  Blue
#property  indicator_color5  Green
#property  indicator_width2  2
#property  indicator_width3  2
#property  indicator_width4  1
#property  indicator_width5  1

extern int ma1=5;
extern int ma2=21;
extern int ma0=55;
extern int ma4=89;


double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];
double     ExtBuffer3[];
double     ExtBuffer4[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   SetIndexDrawBegin(3,ExtBuffer3);
   SetIndexDrawBegin(4,ExtBuffer4);
  // SetIndexDrawBegin(0,34);
  // SetIndexDrawBegin(1,34);
  // SetIndexDrawBegin(2,34);
//---- 4 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("RMS_V("+ma1+","+ma2+","+ma0+","+ma4+")");
   //SetIndexLabel(0,"MACD");
   //SetIndexLabel(3,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----
   for(int i=0; i<limit; i++)
   {
      double ma_1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,i);
      double ma_2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,i);
      double ma_0=iMA(Symbol(),0,ma0,0,MODE_EMA,PRICE_CLOSE,i);
      double ma_4=iMA(Symbol(),0,ma4,0,MODE_EMA,PRICE_CLOSE,i);
      
      double Div1=(ma_2-ma_0);
      double Div2=(ma_1-ma_0);
      double Div3=(ma_0-ma_4);
      
      ExtBuffer3[i]=Div1; 
      ExtBuffer4[i]=Div3; 
      ExtBuffer0[i]=Div2;
   }
   
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
     }
     
  /*    for(int i=0; i<limit; i++)
   {
      double ma_1=iMA(Symbol(),0,ma1,0,MODE_EMA,PRICE_CLOSE,i);
      double ma_2=iMA(Symbol(),0,ma2,0,MODE_EMA,PRICE_CLOSE,i);
      double ma_0=iMA(Symbol(),0,ma0,0,MODE_EMA,PRICE_CLOSE,i);
      
      double Div1=(ma_1-ma_2);
      
      SignalBuffer[i]=Div1;
   }*/
     
//----
   return(0);
  }
//+------------------------------------------------------------------+